From 18f96411c49c8f1a4c8e9dba5a552d8e6edab434 Mon Sep 17 00:00:00 2001
From: Nitheesh Sekar <nsekar@codeaurora.org>
Date: Fri, 30 Nov 2018 19:07:47 +0530
Subject: [PATCH 16/26] TEMP: NOT FOR REVIEW: qcs405: Add bl31 stage and elf

Change-Id: I967c0b78a3561574609bf8332a22838c85e43429
Signed-off-by: Nitheesh Sekar <nsekar@codeaurora.org>
Signed-off-by: Sricharan R <sricharan@codeaurora.org>
---
 src/soc/qualcomm/qcs405/Kconfig                    |  1 +
 src/soc/qualcomm/qcs405/Makefile.inc               |  1 +
 src/soc/qualcomm/qcs405/bl31_plat_params.c         | 40 +++++++++++++++++++++
 .../qualcomm/qcs405/include/soc/bl31_plat_params.h | 42 ++++++++++++++++++++++
 src/soc/qualcomm/qcs405/soc.c                      |  6 ++++
 5 files changed, 90 insertions(+)
 create mode 100644 src/soc/qualcomm/qcs405/bl31_plat_params.c
 create mode 100644 src/soc/qualcomm/qcs405/include/soc/bl31_plat_params.h

diff --git a/src/soc/qualcomm/qcs405/Kconfig b/src/soc/qualcomm/qcs405/Kconfig
index aa867c2f25e9..1c8a30a06c4d 100644
--- a/src/soc/qualcomm/qcs405/Kconfig
+++ b/src/soc/qualcomm/qcs405/Kconfig
@@ -6,6 +6,7 @@ config SOC_QUALCOMM_QCS405
 	select ARCH_RAMSTAGE_ARMV8_64
 	select ARCH_ROMSTAGE_ARMV8_64
 	select ARCH_VERSTAGE_ARMV8_64
+	select ARM64_USE_ARM_TRUSTED_FIRMWARE
 	select BOOTBLOCK_CONSOLE
 	select GENERIC_GPIO_LIB
 	select GENERIC_UDELAY
diff --git a/src/soc/qualcomm/qcs405/Makefile.inc b/src/soc/qualcomm/qcs405/Makefile.inc
index 1af7c0377616..e52178ef9479 100644
--- a/src/soc/qualcomm/qcs405/Makefile.inc
+++ b/src/soc/qualcomm/qcs405/Makefile.inc
@@ -38,6 +38,7 @@ ramstage-y += clock.c
 ramstage-y += usb.c
 ramstage-$(CONFIG_DRIVERS_UART) += uart.c
 ramstage-y += rpm_load_reset.c
+ramstage-y += bl31_plat_params.c
 
 ################################################################################
 
diff --git a/src/soc/qualcomm/qcs405/bl31_plat_params.c b/src/soc/qualcomm/qcs405/bl31_plat_params.c
new file mode 100644
index 000000000000..68a3c14edfec
--- /dev/null
+++ b/src/soc/qualcomm/qcs405/bl31_plat_params.c
@@ -0,0 +1,40 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright 2018 Qualcomm Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <arm_tf.h>
+#include <assert.h>
+#include <cbmem.h>
+#include <soc/bl31_plat_params.h>
+
+static struct bl31_plat_param *plat_params;
+
+void register_bl31_param(struct bl31_plat_param *param)
+{
+	param->next = plat_params;
+	plat_params = param;
+}
+
+void *soc_get_bl31_plat_params(bl31_params_t *bl31_params)
+{
+	static struct bl31_u64_param cbtable_param = {
+		.h = { .type = PARAM_COREBOOT_TABLE, },
+	};
+	if (!cbtable_param.value) {
+		cbtable_param.value = (uint64_t)cbmem_find(CBMEM_ID_CBTABLE);
+		if (cbtable_param.value)
+			register_bl31_param(&cbtable_param.h);
+	}
+	return plat_params;
+}
diff --git a/src/soc/qualcomm/qcs405/include/soc/bl31_plat_params.h b/src/soc/qualcomm/qcs405/include/soc/bl31_plat_params.h
new file mode 100644
index 000000000000..d7a8e2817c64
--- /dev/null
+++ b/src/soc/qualcomm/qcs405/include/soc/bl31_plat_params.h
@@ -0,0 +1,42 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright 2018 Qualcomm Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __BL31_PLAT_PARAMS_H__
+#define __BL31_PLAT_PARAMS_H__
+
+#if 0
+#include <arm-trusted-firmware/plat/qti/common/inc/qti_plat_params.h>
+#else
+/* param type */
+enum {
+	PARAM_NONE = 0,
+	PARAM_COREBOOT_TABLE,
+};
+
+/* common header for all plat parameter type */
+struct bl31_plat_param {
+	uint64_t type;
+	void *next;
+};
+
+struct bl31_u64_param {
+	struct bl31_plat_param h;
+	uint64_t value;
+};
+#endif
+
+void register_bl31_param(struct bl31_plat_param *param);
+
+#endif/* __BL31_PLAT_PARAMS_H__ */
diff --git a/src/soc/qualcomm/qcs405/soc.c b/src/soc/qualcomm/qcs405/soc.c
index 693ce7a872f6..ea52eb821a4a 100644
--- a/src/soc/qualcomm/qcs405/soc.c
+++ b/src/soc/qualcomm/qcs405/soc.c
@@ -13,6 +13,7 @@
  * GNU General Public License for more details.
  */
 
+#include <bootmem.h>
 #include <symbols.h>
 #include <device/device.h>
 #include <timestamp.h>
@@ -20,6 +21,11 @@
 #include <soc/symbols.h>
 #include <soc/rpm.h>
 
+void bootmem_platform_add_ranges(void)
+{
+	bootmem_add_range((uintptr_t)_dram_reserved, _dram_reserved_size, BM_MEM_BL31);
+}
+
 static void soc_read_resources(struct device *dev)
 {
 	ram_resource(dev, 0, (uintptr_t)_dram / KiB, (1 * GiB) / KiB);
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

